import { DefineComponent } from './additionalTypes';
import { RecordPropsDefinition, ComponentOptions, Vue2type } from './additionalTypes';
declare type DefaultData<V> = object | ((this: V) => {});
declare type DefaultMethods<V> = {
    [key: string]: (this: V, ...args: any[]) => any;
};
import { Position } from './models/Position';
import { PopupProps } from './models/PopupProps';
import { AlignService } from './services/alignService';
import { DOMService } from './services/domService';
import { PositionService } from './services/positionService';
/**
 * @hidden
 */
export interface PropsWithChildren extends PopupProps {
    children?: any;
}
/**
 * @hidden
 */
export interface PopupMethods {
    [key: string]: any;
    onOpened: () => void;
    onClosing: () => void;
    onClosed: () => void;
    transitionDuration: () => any;
    getParentRef: (anchor: string, isAnchor?: boolean) => any;
    position: (settings: PopupProps, element: HTMLElement, anchor: string) => Position;
    calculatePosition: ($props: any, appendToElement?: HTMLElement) => Position;
    attachRepositionHandlers: (element: any) => void;
    detachRepositionHandlers: () => void;
    reposition: () => void;
}
/**
 * @hidden
 */
export interface PopupState {
    mountedAppendTo: any;
    mountedAnchor: any;
    _parentElement: any;
    _alignService: AlignService;
    _positionService: PositionService;
    _domService: DOMService;
    _flipped: boolean;
    _offsetTop: number;
    _offsetLeft: number;
    _scrollableParents: Array<HTMLElement> | undefined;
    _exitingAnimation: boolean | undefined;
    _prevShow?: boolean;
    _clonedElement: any;
    v3: boolean;
}
/**
 * @hidden
 */
export interface PopupData {
    hasMounted: boolean;
}
/**
 * @hidden
 */
export interface PopupAll extends PopupMethods, PopupState, PopupData, Vue2type {
}
/**
 * @hidden
 */
declare let PopupVue2: ComponentOptions<Vue2type, DefaultData<PopupData>, DefaultMethods<PopupAll>, {}, RecordPropsDefinition<PopupProps>>;
/**
 * @hidden
 */
declare const Popup: DefineComponent<PopupProps, any, PopupData, {}, PopupMethods, {}, {}, {}, string, PopupProps, PopupProps, {}>;
export { Popup, PopupVue2 };
